//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.LenL.dll;

using System;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Reflection;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.LenL.BusinessObjects.Definitions.Tables;



namespace AddUFDs
{
    class Program
    {
        static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US_314;ExtraDb=PMX_SBODemo_US_314;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2005;DBCultureInfo=en-US;LicenseServer=localhost:30000";

        static void Main(string[] args)
        {
            using ( TransactionScope scope = PmxDbConnection.GetNewTransactionScope() )
            {
                using ( SboConnection conn = new SboConnection(CONNECTION_STRING) )
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);

                    SboColumnDefinitionAttribute colDef = new SboColumnDefinitionAttribute(SboPaymentTermsTypeTableLenL.Columns.Rembours.NAME, "Rembours (COD)", SboFieldType.Alpha, 1, SboFieldSubType.None);
                    colDef.DefaultValue = SboBooleanColumnValues.N.VALUE;
                    colDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
                    udfProv.AddUpdateUserfield(SboPaymentTermsTypeTableLenL.NAME, colDef);  // OCTG

                }

                //Complete transaction
                scope.Complete();
            }
            Console.WriteLine("Done ...");

        }

    }
}
