﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.LenL.dll;

using System;
using System.Transactions;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Resources;
using System.Reflection;
using Produmex.Foundation.Diagnostics;
using Produmex.Sbo.Logex.LenL;
using Produmex.Sbo.Logex.LenL.BusinessObjects;
using Produmex.Sbo.Logex.LenL.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.LenL.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.LenL.Providers;

namespace AddUpdateData
{
    class Program
    {
        static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US_314;ExtraDb=PMX_SBODemo_US_314;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2005;DBCultureInfo=en-US;LicenseServer=localhost:30000";


        /// <summary>
        /// Used for logging
        /// </summary>
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);


        static void Main(string[] args)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    PmxDbVersionUpdaterProvider dbVersionProv = new PmxDbVersionUpdaterProvider(conn);

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesLenL.UPS_ACCOUNT_NUMBER,
                        "L&L - UPS label Account Number",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        "123456", 
                        PmxExtensionParameterCodesLenL.UPS_ACCOUNT_NUMBER.Substring(4));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesLenL.UPS_SERVICE_CODE,
                        "L&L - UPS label Service Indicator",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        "78",
                        PmxExtensionParameterCodesLenL.UPS_SERVICE_CODE.Substring(4));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesLenL.UPS_FIRST_PTN,
                        "L&L - UPS label eerste PTN",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR,
                        "0",
                        PmxExtensionParameterCodesLenL.UPS_FIRST_PTN.Substring(4));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesLenL.UPS_LAST_PTN,
                        "L&L - UPS label laatste PTN",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR,
                        "9999999",
                        PmxExtensionParameterCodesLenL.UPS_LAST_PTN.Substring(4));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesLenL.UPS_NEXT_PTN,
                        "L&L - UPS label volgende PTN",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR,
                        "000000",
                        PmxExtensionParameterCodesLenL.UPS_NEXT_PTN.Substring(4));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesLenL.UPS_XML_OUT_DIR,
                        "L&L - UPS label export folder",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"C:\UPS\WSTD\ImpExp\Auto Import",
                        PmxExtensionParameterCodesLenL.UPS_XML_OUT_DIR.Substring(4));
                }

                //Complete transaction
                scope.Complete();
            }


            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    Console.WriteLine("Add table PMX_LL_UPSN");
                    RunTableSqlScript("PMX_LL_UPSN.sql", conn);
                }

                //Complete transaction
                scope.Complete();
            }
        }

        /// <summary>
        /// Runs the table SQL script.
        /// </summary>
        /// <param name="tableScript">The table script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(PmxLogisticUnitIDTableLenL)), "Produmex.Sbo.Logex.LenL.Scripts.Tables." + tableScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }

        /// <summary>
        /// Add/update application type
        /// </summary>
        /// <param name="code">The code of the config</param>
        /// <param name="name">The name of the config</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="isSystemConfig">if set to <c>true</c> [is system config].</param>
        /// <param name="configValue">The config value.</param>
        /// <param name="dbConn">The db conn.</param>
        private static void AddUpdatePmxConfig( string code, string name, string convertorCode, bool isSystemConfig, string configValue, PmxDbConnection dbConn )
        {
            PmxConfigProvider prov = new PmxConfigProvider(dbConn);
            PmxConfig bo = null;
            try
            {
                bool newBo = false;
                bo = prov.GetBO(code);
                if ( bo == null )
                {
                    newBo = true;
                    bo = prov.GetNewBO();
                    bo.Code = code;
                    bo.ConfigValue = configValue;  // Assign value only on new, not on update
                }
                bo.Name = name;
                bo.ConvertorCode = convertorCode;
                bo.IsSystemConfig = isSystemConfig;
                if ( newBo )
                {
                    prov.AddBO(bo);
                }
                else
                {
                    prov.UpdateBO(bo ,false , false);
                }
            }
            finally
            {
                if ( bo != null ) bo.Dispose();
            }
        }

    }
}
